from yarll.agents.registration import register_agent, make_agent

register_agent(name="A2C",
               entry_point="yarll.agents.tf2.actorcritic.a2c:A2CDiscrete",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="A2C",
               entry_point="yarll.agents.tf2.actorcritic.a2c:A2CDiscreteCNN",
               state_dimensions="multi",
               action_space="discrete"
              )
register_agent(name="A2C",
               entry_point="yarll.agents.tf2.actorcritic.a2c:A2CDiscreteCNNRNN",
               state_dimensions="multi",
               action_space="discrete",
               rnn=True
              )
register_agent(name="A2C",
               entry_point="yarll.agents.tf2.actorcritic.a2c:A2CContinuous",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="A3C",
               entry_point="yarll.agents.tf1.actorcritic.a3c:A3CDiscrete",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="A3C",
               entry_point="yarll.agents.tf1.actorcritic.a3c:A3CDiscreteCNN",
               state_dimensions="multi",
               action_space="discrete"
              )
register_agent(name="A3C",
               entry_point="yarll.agents.tf1.actorcritic.a3c:A3CDiscreteCNNRNN",
               state_dimensions="multi",
               action_space="discrete",
               rnn=True
              )
register_agent(name="A3C",
               entry_point="yarll.agents.tf1.actorcritic.a3c:A3CContinuous",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="AsyncKnowledgeTransfer",
               entry_point="yarll.agents.tf1.knowledgetransfer.async_knowledge_transfer:AsyncKnowledgeTransfer",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="PPO",
               entry_point="yarll.agents.tf2.ppo.ppo:PPODiscrete",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="PPO",
               entry_point="yarll.agents.tf2.ppo.ppo:PPOBernoulli",
               state_dimensions="continuous",
               action_space="multibinary"
               )
register_agent(name="PPO",
               entry_point="yarll.agents.tf2.ppo.ppo:PPODiscreteCNN",
               state_dimensions="multi",
               action_space="discrete"
              )
register_agent(name="PPO",
               entry_point="yarll.agents.tf2.ppo.ppo:PPOContinuous",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="PPO",
               entry_point="yarll.agents.tf2.ppo.ppo:PPOMultiDiscrete",
               state_dimensions="continuous",
               action_space="multidiscrete"
               )
register_agent(name="DPPO",
               entry_point="yarll.agents.tf2.ppo.dppo:DPPODiscrete",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="DPPO",
               entry_point="yarll.agents.tf2.ppo.dppo:DPPODiscreteCNN",
               state_dimensions="multi",
               action_space="discrete"
              )
register_agent(name="DPPO",
               entry_point="yarll.agents.tf2.ppo.dppo:DPPOContinuous",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="TRPO",
               entry_point="yarll.agents.tf2.trpo.trpo:TRPODiscrete",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="TRPO",
               entry_point="yarll.agents.tf2.trpo.trpo:TRPODiscreteCNN",
               state_dimensions="multi",
               action_space="discrete"
              )
register_agent(name="TRPO",
               entry_point="yarll.agents.tf2.trpo.trpo:TRPOContinuous",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="DTRPO",
               entry_point="yarll.agents.tf2.trpo.dtrpo:DTRPODiscrete",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="DTRPO",
               entry_point="yarll.agents.tf2.trpo.dtrpo:DTRPODiscreteCNN",
               state_dimensions="multi",
               action_space="discrete"
              )
register_agent(name="DTRPO",
               entry_point="yarll.agents.tf2.trpo.dtrpo:DTRPOContinuous",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="DDPG",
               entry_point="yarll.agents.tf2.ddpg:DDPG",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="CEM",
               entry_point="yarll.agents.basic.cem:CEM",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="CEM",
               entry_point="yarll.agents.basic.cem:CEM",
               state_dimensions="continuous",
               action_space="multibinary"
               )
register_agent(name="CEM",
               entry_point="yarll.agents.basic.cem:CEM",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="KnowledgeTransfer",
               entry_point="yarll.agents.tf1.knowledge_transfer:KnowledgeTransfer",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.tf2.reinforce:REINFORCEDiscrete",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.tf2.reinforce:REINFORCEDiscreteRNN",
               state_dimensions="continuous",
               action_space="discrete",
               rnn=True
              )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.tf2.reinforce:REINFORCEBernoulli",
               state_dimensions="continuous",
               action_space="multibinary"
               )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.tf2.reinforce:REINFORCEDiscreteCNN",
               state_dimensions="multi",
               action_space="discrete"
              )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.tf2.reinforce:REINFORCEDiscreteCNNRNN",
               state_dimensions="multi",
               action_space="discrete",
               rnn=True
              )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.tf2.reinforce:REINFORCEContinuous",
               state_dimensions="continuous",
               action_space="continuous"
              )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.tf2.reinforce:REINFORCEContinuous",
               state_dimensions="continuous",
               action_space="continuous",
               rnn=True
               )
register_agent(name="REINFORCE",
               entry_point="yarll.agents.pytorch.reinforce:REINFORCEContinuous",
               state_dimensions="continuous",
               action_space="continuous",
               backend="pytorch",
               )
register_agent(name="SarsaFA",
               entry_point="yarll.agents.basic.sarsa.sarsa_fa:SarsaFA",
               state_dimensions="continuous",
               action_space="discrete"
              )
register_agent(name="SAC",
               entry_point="yarll.agents.tf2.sac:SAC",
               state_dimensions="continuous",
               action_space="continuous"
               )
register_agent(name="SAC",
               entry_point="yarll.agents.pytorch.sac:SAC",
               state_dimensions="continuous",
               action_space="continuous",
               backend="pytorch",
               )
register_agent(name="QLearning",
               entry_point="yarll.agents.basic.q_learning:QLearning",
               state_dimensions="discrete",
               action_space="discrete")
register_agent(name="FittedQIteration",
               entry_point="yarll.agents.tf2.fitted_q:FittedQIteration",
               state_dimensions="continuous",
               action_space="discrete"
               )
register_agent(name="DQN",
               entry_point="yarll.agents.tf2.dqn:DQN",
               state_dimensions="continuous",
               action_space="discrete")
